#include "Transformador.h"

extern PegBitmap gbTRFBitmap;

Transformador::Transformador(PegRect rect, CPMainFrame* frame):CPModuleWindow(rect,0,0,frame)
{
 init();
}

int Transformador::init()
{   
   	const WORD wStyle = FF_NONE|TJ_LEFT|AF_TRANSPARENT| TT_COPY;
	const SIGNED margin = 10;
	const SIGNED width=mClient.Width()-2*margin;
    int xoff;    
    PegRect rectangle;
 	PEGCHAR* chr2 = "\xED\xF2"; 
 
    xoff = 40;
 	PegPrompt* l1 = new PegPrompt(margin, xoff+=15, width, "Ip(A):",0,wStyle);
 	PegPrompt* l2 = new PegPrompt(margin, xoff+=15, 40, "Vp:",0,wStyle);
 	PegPrompt* l3 = new PegPrompt(margin+width/2+10, xoff, 40, "Vs:",0,wStyle);
 	PegPrompt* l4 = new PegPrompt(margin, xoff+=15, width, "S(cm"+CPString(chr2)+"):",0,wStyle);
 	PegPrompt* l5 = new PegPrompt(margin, xoff+=15, width, "f(Hz):",0,wStyle);
	AddR(l1);
	AddR(l2);	
	AddR(l3);	
	AddR(l4);	
	AddR(l5);	

    xoff = 40;
 	Ip = new CPPegString(margin+40,xoff+=15,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	Vp = new CPPegString(margin+20,xoff+=15,40,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	Vs = new CPPegString(width/2+margin+30,xoff,40,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	S = new CPPegString(margin+40,xoff+=15,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	f = new CPPegString(margin+40,xoff+=15,width - 70,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(Ip);
	AddR(Vp);	
	AddR(Vs);	
	AddR(S);	
	AddR(f);
    	
     //rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM);
    rectangle.Set(45, 115, 100, 130);
   	PegTextButton* b3 = new PegTextButton(rectangle, "Calcular!", BOTO, AF_ENABLED|TJ_CENTER);
	AddR(b3);
	
	res1 = new PegPrompt(margin, 135, width, "",0,wStyle);
	res2 = new PegPrompt(margin, 150, width, "",0,wStyle);
	res3 = new PegPrompt(margin, 165, width, "",0,wStyle);
	res4 = new PegPrompt(margin, 180, width, "",0,wStyle);
 	AddR(res1); 
 	AddR(res2); 
 	AddR(res3); 
	AddR(res4); 
	
    rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_TOP+50);
 	PegBitmapButton * imatge = new PegBitmapButton(rectangle,&gbTRFBitmap,0,AF_TRANSPARENT,TYPE_PROMPT,FALSE);
 	AddR(imatge); 
 	
	return 0;
}

void Transformador::Draw()
{
	BeginDraw();
	Invalidate(mClient);
	DrawFrame();
	DrawChildren();
	EndDraw();
}

SIGNED Transformador::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
	{
		case SIGNAL(BOTO, PSF_CLICKED):
		{
             Calcula();
		}


		break;
		
		default:
		return CPModuleWindow::Message(Mesg);
	}
	return 0;
}

WORD Transformador::Dialog(char* title, char* message)
{
	PegRect rr = GetMainFrame()->TopAppRectangle();
	rr.wBottom -= 30;
	rr.wRight -= 10;
	rr.wTop += 10;
	rr.wLeft += 10;
	PegMessageWindow *msg = new PegMessageWindow(rr, title, message, MW_OK, 0,0,0);
	return msg->Execute();
}

void Transformador::Calcula()
{   
    obcd aux,aux2,aux3,aux4;
    
    // Calcula Potencia
    aux = CPExpression(Ip->DataGet());
    aux2 = CPExpression(Vp->DataGet());
    Cal_mul_OBC(&aux,&aux2);
    aux3 = aux;
    
    // Calcula Is
    aux2 = CPExpression(Vs->DataGet());
    Cal_div_OBC(&aux3,&aux2);
    aux4 = aux3;
    Cal_cintx_OBC(&aux,5);
    Cal_cintx_OBC(&aux3,5);
    
    res1 -> DataSet("P="+CPString(aux)+" W  Is="+CPString(aux3)+" A");
    
    // Calcula R.T.
    aux = CPExpression(Vp->DataGet()); 
    Cal_div_OBC(&aux2,&aux);
    Cal_cintx_OBC(&aux2,4);
    res2 -> DataSet("R.T. = 1:"+CPString(aux2));
    
     // Calcula Np
     aux = getN_V();
     aux2 =  CPExpression(Vp->DataGet()); 
     Cal_mul_OBC(&aux,&aux2);
     aux2 = ceiling(aux);
     aux3 = aux2;
     
     // Calcula Ns
     aux = getN_V();
     aux2 =  CPExpression(Vs->DataGet()); 
     Cal_mul_OBC(&aux,&aux2);
     aux2 = ceiling(aux);
     res3->DataSet("Np="+CPString(aux3)+"   Ns="+CPString(aux2));
     
     // Calcula Dp
     aux = calc_q();
     aux2 =  CPExpression(Ip->DataGet()); 
     Cal_div_OBC(&aux2,&aux);
     aux = getRfromS(aux2);
     ExecuteToOBCD("2",aux2);
     Cal_mul_OBC(&aux,&aux2);
     aux3 = aux;
     
     // Calcula Ds
     aux = calc_q();
     Cal_div_OBC(&aux4,&aux);
     aux = getRfromS(aux4);
     ExecuteToOBCD("2",aux2);
     Cal_mul_OBC(&aux,&aux2);
     
     Cal_cintx_OBC(&aux3,4);
     Cal_cintx_OBC(&aux,4);
     
     res4->DataSet("Dp="+CPString(aux3)+"mm  Ds="+CPString(aux)+"mm");
      
    Draw();    
    
} 
  
obcd Transformador::getRfromS(obcd sup)
{
    obcd aux;
    
    Cal_setpi_OBC(&aux);
    Cal_div_OBC(&sup,&aux);
    Cal_sqrt_OBC(&sup);
    
    return sup;
}   

obcd Transformador::getN_V()
{
    obcd aux, aux2;
    
    ExecuteToOBCD("2250",aux);
    aux2 = CPExpression(f->DataGet()); 
    Cal_div_OBC(&aux,&aux2);
    aux2 = CPExpression(S->DataGet());
    Cal_div_OBC(&aux,&aux2);
    return aux;    
}

obcd Transformador::calc_q()
{
    obcd aux, aux2;
    
    aux2 = CPExpression(S->DataGet());
    Cal_square_OBC(&aux2);
    ExecuteToOBCD("576",aux);
    Cal_div_OBC(&aux2,&aux);
    aux = CPExpression(Vp->DataGet());
    Cal_div_OBC(&aux2,&aux);
    aux = CPExpression(Ip->DataGet());
    Cal_div_OBC(&aux2,&aux);
    aux = CPExpression(f->DataGet());
    Cal_mul_OBC(&aux2,&aux);
    ExecuteToOBCD("40",aux); 
    Cal_mul_OBC(&aux2,&aux);
    
    return aux2;    
}
    
extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
return "";
}
